#
# Conditional build:
%bcond_with	tests	# unit tests (can fail under heavy system load)
%bcond_without	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module

Summary:	Very fast asynchronous FTP server library for Python 2
Summary(pl.UTF-8):	Bardzo szybka biblioteka asynchronicznego serwera FTP dla Pythona 2
Name:		python-pyftpdlib
Version:	1.5.7
Release:	1
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.python.org/simple/pyftpdlib/
Source0:	https://files.pythonhosted.org/packages/source/p/pyftpdlib/pyftpdlib-%{version}.tar.gz
# Source0-md5:	6d9539aea866d4f959d86ae001cdddf7
URL:		https://github.com/giampaolo/pyftpdlib/
%if %{with python2}
BuildRequires:	python-modules >= 1:2.6
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-pyOpenSSL
BuildRequires:	python-pysendfile >= 1.5
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-pyOpenSSL
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
Requires:	python-modules >= 1:2.6
Suggests:	python-pyOpenSSL
Suggests:	python-pysendfile >= 1.5
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Python FTP server library provides a high-level portable interface to
easily write very efficient, scalable and asynchronous FTP servers
with Python. It is the most complete RFC-959 FTP server implementation
available for Python programming language.

%description -l pl.UTF-8
Biblioteka serwera FTP dla Pythona udostępnia wysokopoziomowy,
przenośny interfejs do łatwego tworzenia bardzo wydajnych,
skalowalnych i asynchronicznych serwerów FTP w Pythonie. Jest to
najpełniejsza implementacja serwera FTP wg RFC-959 dostępna dla tego
języka programowania.

%package -n python3-pyftpdlib
Summary:	Very fast asynchronous FTP server library for Python 3
Summary(pl.UTF-8):	Bardzo szybka biblioteka asynchronicznego serwera FTP dla Pythona 3
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.4
Suggests:	python3-pyOpenSSL

%description -n python3-pyftpdlib
Python FTP server library provides a high-level portable interface to
easily write very efficient, scalable and asynchronous FTP servers
with Python. It is the most complete RFC-959 FTP server implementation
available for Python programming language.

%description -n python3-pyftpdlib -l pl.UTF-8
Biblioteka serwera FTP dla Pythona udostępnia wysokopoziomowy,
przenośny interfejs do łatwego tworzenia bardzo wydajnych,
skalowalnych i asynchronicznych serwerów FTP w Pythonie. Jest to
najpełniejsza implementacja serwera FTP wg RFC-959 dostępna dla tego
języka programowania.

%prep
%setup -q -n pyftpdlib-%{version}

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTHONPATH=$(pwd)/build-2/lib \
%{__python} pyftpdlib/test/runner.py
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
PYTHONPATH=$(pwd)/build-3/lib \
%{__python3} pyftpdlib/test/runner.py
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%{__rm} $RPM_BUILD_ROOT%{_bindir}/ftpbench
%{__rm} -r $RPM_BUILD_ROOT%{py_sitescriptdir}/pyftpdlib/test
%endif

%if %{with python3}
%py3_install
%{__rm} $RPM_BUILD_ROOT%{_bindir}/ftpbench
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/pyftpdlib/test
%endif

# in case there are examples provided
%if %{with python2}
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -a demo/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
%{__sed} -i -e '1s,/usr/bin/env python3,%{__python},' \
	$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/*.py
%endif
%if %{with python3}
install -d $RPM_BUILD_ROOT%{_examplesdir}/python3-pyftpdlib-%{version}
cp -a demo/* $RPM_BUILD_ROOT%{_examplesdir}/python3-pyftpdlib-%{version}
%{__sed} -i -e '1s,/usr/bin/env python3,%{__python3},' \
	$RPM_BUILD_ROOT%{_examplesdir}/python3-pyftpdlib-%{version}/*.py
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CREDITS HISTORY.rst LICENSE README.rst
%{py_sitescriptdir}/pyftpdlib
%{py_sitescriptdir}/pyftpdlib-%{version}-py*.egg-info
%{_examplesdir}/%{name}-%{version}
%endif

%if %{with python3}
%files -n python3-pyftpdlib
%defattr(644,root,root,755)
%doc CREDITS HISTORY.rst LICENSE README.rst
%{py3_sitescriptdir}/pyftpdlib
%{py3_sitescriptdir}/pyftpdlib-%{version}-py*.egg-info
%{_examplesdir}/python3-pyftpdlib-%{version}
%endif
%changelog
* Mon Jan 02 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-pyftpdlib.git;a=log;h=master

* Mon Jan 02 2023 Jakub Bogusz <qboosh@pld-linux.org> c470b8c
- updated to 1.5.7
- removed obsolete tests patch

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 06ea32e
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 2bfd772
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 5206727
- rebuild with python 3.10

* Tue Mar 22 2022 Jakub Bogusz <qboosh@pld-linux.org> dacd619
- updated to 1.5.6
- removed obsolete sendfile patch

* Mon Mar 08 2021 Jan Rękorajski <baggins@pld-linux.org> 408e37b
- release 4 (by relup.sh)

* Mon Mar 08 2021 Jan Rękorajski <baggins@pld-linux.org> 95197b7
- fix shebangs

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 7636eea
- rebuild with python 3.8
- release 3 (by relup.sh)

* Sun Oct 06 2019 Jan Rękorajski <baggins@pld-linux.org> fe44798
- test suite is FUBAR, disable it
- rel 2

* Sat Oct 05 2019 Jakub Bogusz <qboosh@pld-linux.org> 30b1612
- updated to 1.5.5
- update tests patch (now two tests fail, not only in PLD)
- removed obsolete mock patch
- added sendfile patch (don't require pysendfile for tests under python 3.4+)

* Tue Jul 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 4c12faf
- release 2 (by relup.sh)

* Sat Mar 25 2017 Jakub Bogusz <qboosh@pld-linux.org> c43f343
- new

